/***************************************************

simple lua sleep module to sleep in seconds, miliseconds and microseconds 

how to sleep in lua is one of the most popular asked 
questions on lists.

this is bluntly inspired by  Daniel Aquino 
( see http://lua-users.org/lists/lua-l/2010-10/msg00338.html )

as its really trivial i place this module hereby in the public domain.

for complains contact startx < startx@plentyfact.org >

****************************************************

[luaproc.c]

****************************************************/


#include <lua.h>
#include <lualib.h>
#include <lauxlib.h>
#include <unistd.h>

static int l_usleep(lua_State *L)
{
	usleep( luaL_checkint(L,-1) );
	return 0;
}

static int l_msleep(lua_State *L)
{
	usleep( luaL_checkint(L,-1) * 1000 );
	return 0;
}

static int l_sleep(lua_State *L)
{
	sleep( luaL_checkint(L,-1) );
	return 0;
}


static const struct luaL_Reg functions [] = {
    {"usleep", l_usleep },
    {"msleep", l_msleep },
    {"sleep",  l_sleep  },
    {NULL, NULL}
};

int luaopen_lsleep(lua_State *L) {
    luaL_register(L, "lsleep", functions);
    return 1;
}


